﻿using Sample.Models;
using Syncfusion.JavaScript.Models;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Web;
using System.Web.Mvc;
using System.Web.Script.Serialization;

namespace Sample.Controllers
{
    public partial class HomeController : Controller
    {
        //
        // GET: /Home/

        public ActionResult Index()
        {
            var Data = OrderRepository.GetAllRecords().Take(50).ToList();
            ViewBag.dataSource = Data;
            List<Column> cols = new List<Column>();// Column is a class of Syncfusion Javascript models 
            cols.Add(new Column() { Field = "OrderID", HeaderText = "Order ID" });//Add some column 
            cols.Add(new Column() { Field = "EmployeeID", HeaderText = "EmployeeID" });
            cols.Add(new Column() { Field = "Freight", HeaderText = "Freight" });
            ViewBag.columns = cols; //update them in ViewBag 
            return View();
        }

        [OutputCache(NoStore = true, Duration = 0, VaryByParam = "*")]
        public PartialViewResult GetReport(string table)
        {
            var ds = GetData(table);
            ViewBag.datasource = ds.ToList();
            
            return PartialView("_GridView");

        } // end of PartialViewResult GetReport
        public IEnumerable<object> GetData(string table)
        {
            if (table == "Order")
            {
                var Data = OrderRepository.GetAllRecords().Take(50).ToList();

                EditableOrder order = Data.First();
                Type modelType = order.GetType();
                IList<PropertyInfo> props = new List<PropertyInfo>(modelType.GetProperties());

                IList<object> dataSource = new List<object>();
                IList<string> headers = new List<string>();

                foreach (EditableOrder ord in Data)
                {
                    Dictionary<string, string> dic = new Dictionary<string, string>();
                    foreach (PropertyInfo prop in props)
                    {
                        string propName = prop.Name;
                        var val = prop.GetValue(ord, null);
                        if (val != null)
                        {
                            string header = propName;
                            string myType = val.GetType().Name.ToString();
                            if (myType.ToLower().Contains("list")) // this is ScoreInfo
                            {
                                var scoreInfoLst = (List<EditableOrder>)val;
                                if (scoreInfoLst.Count > 0)
                                {
                                    EditableOrder scoreInfo = scoreInfoLst[0];
                                    header = String.Format("{0} {1} {2}", scoreInfo.OrderID, scoreInfo.CustomerID, propName);
                                    dic.Add(header, scoreInfo.EmployeeID.ToString());
                                    if (!headers.Contains(header))
                                    {
                                        headers.Add(header);
                                    }

                                }
                            }
                            else
                            {
                                if (header == "FirstName") header = "First Name";
                                if (header == "LastName") header = "Last Name";
                                dic.Add(header, val.ToString());
                                if (!headers.Contains(header))
                                {
                                    headers.Add(header);
                                }

                            }
                        }
                    }

                    dataSource.Add((object)dic);
                }

                List<Column> cols = new List<Column>();
                foreach (string h in headers)
                {
                    cols.Add(new Column() { Field = h, HeaderText = h });
                }
                ViewBag.columns = cols;


                return (IEnumerable<object>)dataSource;
            }
            else
            {
                var Data = EmployeeRepository.GetAllRecords().Take(50).ToList();

                EmployeeModel order = Data.First();
                Type modelType = order.GetType();
                IList<PropertyInfo> props = new List<PropertyInfo>(modelType.GetProperties());

                IList<object> dataSource = new List<object>();
                IList<string> headers = new List<string>();

                foreach (EmployeeModel ord in Data)
                {
                    Dictionary<string, string> dic = new Dictionary<string, string>();
                    foreach (PropertyInfo prop in props)
                    {
                        string propName = prop.Name;
                        var val = prop.GetValue(ord, null);
                        if (val != null)
                        {
                            string header = propName;
                            string myType = val.GetType().Name.ToString();
                            if (myType.ToLower().Contains("list")) // this is ScoreInfo
                            {
                                var scoreInfoLst = (List<EmployeeModel>)val;
                                if (scoreInfoLst.Count > 0)
                                {
                                    EmployeeModel scoreInfo = scoreInfoLst[0];
                                    header = String.Format("{0} {1} {2}", scoreInfo.EmployeeID, scoreInfo.FirstName, propName);
                                    dic.Add(header, scoreInfo.EmployeeID.ToString());
                                    if (!headers.Contains(header))
                                    {
                                        headers.Add(header);
                                    }

                                }
                            }
                            else
                            {
                                if (header == "FirstName") header = "First Name";
                                if (header == "LastName") header = "Last Name";
                                dic.Add(header, val.ToString());
                                if (!headers.Contains(header))
                                {
                                    headers.Add(header);
                                }

                            }
                        }
                    }

                    dataSource.Add((object)dic);
                }

                List<Column> cols = new List<Column>();
                foreach (string h in headers)
                {
                    cols.Add(new Column() { Field = h, HeaderText = h });
                }
                ViewBag.columns = cols;


                return (IEnumerable<object>)dataSource;
            }

        } // end of GetStudentsScoresData
    }

   
}
